<?php
include_once('config.php');
require_once('include/logging.php');
require_once('include/utils/utils.php');

require_once("include/HTTP_Session/Session.php");
require_once("include/Webservices/SessionManager.php");


// Checking the validity of session id
$sessionId = $_GET['session_id'];
$sessionManager = new SessionManager();

if(!$sessionId || strcasecmp($sessionId, "null")===0) {
	echo('Error: Invalid Session');
	return;
}
$sid = $sessionManager->startSession($sessionId, false);
if(!$sid) {
	echo('Error: Invalid Session');
	return;
}
$aut_user = $sessionManager->get("authenticatedUserId");


// Database object
$adb = PearDatabase::getInstance();

$query = $_GET['get'];
$valid_query = true;
$query_type = '';

// Determine the type of request
if (substr($query , 0, 3) == 'pl_')
	$query_type = 'picklist';
else if (substr($query , 0, 2) == 's_')
	$query_type = 'search';

// Decode conditions for search request
$conditions = array();
if ($query_type == 'search') {
	if (isset($_GET['conditions']) && !empty($_GET['conditions'])) {
		$conditions_tmp = explode('\/', $_GET['conditions']);
		foreach ($conditions_tmp as $cond) {
			$cond = explode('\:', $cond);
			$conditions[$cond[0]] = mysql_real_escape_string($cond[1]); // Protects sql injection
		}
	}
}



$table_sql = '';
$column_sql = '';
$condition_sql = '';
$limit_sql = '';

// Assigning column names and table names
switch($query) {
	
	case 'pl_leadstatus' :
		$table_sql = 'vtiger_leadstatus';
		$column_sql = 'leadstatus';
		break;
	
	case 'pl_leadsource' :
		$table_sql = 'vtiger_leadsource';
		$column_sql = 'leadsource';
		break;
	
	case 'pl_opportunity_type' :
		$table_sql = 'vtiger_opportunity_type';
		$column_sql = 'opportunity_type';
		break;
	
	case 'pl_sales_stage' :
		$table_sql = 'vtiger_sales_stage';
		$column_sql = 'sales_stage';
		break;
	
	case 'pl_rating' :
		$table_sql = 'vtiger_rating';
		$column_sql = 'rating';
		break;
	
	case 'pl_industry' :
		$table_sql = 'vtiger_industry';
		$column_sql = 'industry';
		break;
	
	case 'pl_accounttype' :
		$table_sql = 'vtiger_accounttype';
		$column_sql = 'accounttype';
		break;

	case 'pl_quotestage' :
		$table_sql = 'vtiger_quotestage';
		$column_sql = 'quotestage';
		break;
	
	case 'pl_postatus' :
		$table_sql = 'vtiger_postatus';
		$column_sql = 'postatus';
		break;
	
	case 'pl_carrier' :
		$table_sql = 'vtiger_carrier';
		$column_sql = 'carrier';
		break;
	
	case 'pl_sostatus' :
		$table_sql = 'vtiger_sostatus';
		$column_sql = 'sostatus';
		break;
		
	case 'pl_invoicestatus' :
		$table_sql = 'vtiger_invoicestatus';
		$column_sql = 'invoicestatus';
		break;	
	
	case 'pl_manufacturer' :
		$table_sql = 'vtiger_manufacturer';
		$column_sql = 'manufacturer';
		break;
	
	case 'pl_productcategory' :
		$table_sql = 'vtiger_productcategory';
		$column_sql = 'productcategory';
		break;
	
	case 'pl_salutationtype' :
	case 'pl_salutation' :
		$table_sql = 'vtiger_salutationtype';
		$column_sql = 'salutationtype';
		break;
	
	case 's_potential' :
		$column_sql = '*';
		$table_sql = 'vtiger_potential p JOIN vtiger_crmentity e ON p.potentialid = e.crmid LEFT JOIN vtiger_contactdetails c ON p.related_to = c.contactid LEFT JOIN vtiger_account a ON p.related_to = a.accountid';
		break;
	
	case 's_permission' :
		$column_sql = 'stufftitle, visible';
		$table_sql = 'vtiger_homestuff';
		break;
	
	case 's_user' :
		$column_sql = 'id, user_name, first_name, last_name';
		$table_sql = 'vtiger_users';
		$conditions = array();
		break;
	
	default :
		$valid_query = false;
		break;
}

if ($valid_query) {
	
	// Give operators more adapted to the conditions
	if ($query_type == 'search') {
		if (isset($_GET['limit']))
			$limite_sql = 'LIMIT '.$_GET['limit'].', 10';
		
		if (isset($_GET['mode']))
			if ($_GET['mode'] == 'count')
				$column_sql = 'COUNT(*)';
		
		if (sizeof($conditions) > 0) {
			$is_first = true;
			foreach ($conditions as $key => $val) {
				if ($is_first) {
					$condition_sql .= ' WHERE ';
					$is_first = false;
				}
				else
					$condition_sql .= ' AND ';
				
				switch ($key) {
					case 'related_to' :
						$condition_sql .= "( lastname LIKE '%".$val."%' OR firstname LIKE '%".$val."%' OR accountname LIKE '%".$val."%' )";
						break;
					
					case 'probability' :
						$condition_sql .= $key." >= ".$val;
						break;
					
					case 'opportunity_type' :
					case 'leadsource' :
					case 'sales_stage' :
					case 'userid' :
					case 'crmid' :
						$condition_sql .= $key." = '".$val."'";
						break;
				
					case 'assigned_user_id' :
						$condition_sql .= "smownerid = ".substr($val, 3, 8);
						break;
					
					default:
						$condition_sql .= $key." LIKE '%".$val."%'";
						break;
				}
			}
		}
	}
	
	// Launch request to DataBase
	$sql = 'SELECT '.$column_sql.' FROM '.$table_sql.$condition_sql.' '.$limite_sql.' ;';
	$res = $adb->pquery($sql, array());
	
	// Print results
	if ($query_type == 'picklist') {
		$str = '';
	
		while ($row = $adb->fetch_array($res)) {
			if ($query_type == 'picklist')
				$str .= $row[$column_sql].'/';
			else if ($query_type == 'search') {
				foreach ($row as $key => $value)
					if (!is_numeric($key))
						$str .= $key.'\:'.$value.'\/';
				$str .= '<br>';
			}
		}
		
		$str = substr_replace($str, '', -2);
		echo($str);
	}
	else if ($query_type == 'search') {
		while ($row = $adb->fetch_array($res)) {
			if (isset($row['potentialid']))
				$row['id'] = $row['potentialid'];
			$rows[] = $row;
		}
		echo(json_encode($rows)); 
	}
	
}
else {
	echo('Error: Invalid Request');
}
?>